/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2020 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_userdefine.h
* Version      : 1.0.2
* Device(s)    : R7F100GSNxFB
* Description  : User header file for code generation.
* Creation Date: 2021-12-09
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
/* Start user code for include. Do not edit comment generated here */
#include <stdbool.h>
#include "r_rfd_common_api.h"
#include "r_rfd_compiler.h"
/* End user code. Do not edit comment generated here */

#ifndef USER_DEF_H
#define USER_DEF_H

/***********************************************************************************************************************
Macro definitions (Register bit)
***********************************************************************************************************************/
/* Start user code for register. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/
/* Start user code for macro define. Do not edit comment generated here */

//gpROMTCYɂăRgAEgύXĂ

//#define ROM_SIZE_96KB		0x01
//#define ROM_SIZE_128KB		0x01
//#define ROM_SIZE_192KB		0x01
//#define ROM_SIZE_256KB		0x01
//#define ROM_SIZE_384KB		0x01
//#define ROM_SIZE_512KB		0x01
#define ROM_SIZE_768KB		0x01


#define LED_ON          (0x01)
#define LED_OFF         (0x00)

#define WRITE_DATA_SIZE         (256UL)
#define CF_BLOCK_SIZE           (2048)
#define BT1_START_ADDRESS       (0x00004000)
#define BT1_END_ADDRESS         (0x00007FFF)
#define EXECUTE_START_ADDRESS   (0x00008000UL)

#define CPU_FREQUENCY           (32u)

#define PROGRAMMABLE_MODE       (1)
#define UNPROGRAMMABLE_MODE     (0)

#define COMMAND_START         (0x02)
#define COMMAND_WRITE_BOOT1   (0x03)
#define COMMAND_WRITE_TEMP    (0x04)
#define COMMAND_END           (0x05)
#define COMMAND_ERROR         (0xFF)

#define VALUE_U08_MASK1_FSQ_STATUS_ERR_ERASE             (0x01)
#define VALUE_U08_MASK1_FSQ_STATUS_ERR_WRITE             (0x02)
#define VALUE_U08_MASK1_FSQ_STATUS_ERR_BLANKCHECK        (0x08)
#define VALUE_U08_MASK1_FSQ_STATUS_ERR_CFDF_SEQUENCER    (0x10)
#define VALUE_U08_MASK1_FSQ_STATUS_ERR_EXTRA_SEQUENCER   (0x20)

#define VALUE_U08_SHIFT_ADDR_TO_BLOCK_CF    (11)

#define VALUE_U01_MASK0_1BIT    (0u)
#define VALUE_U01_MASK1_1BIT    (1u)
#define VALUE_U08_MASK0_8BIT    (0x00u)
#define VALUE_U08_MASK1_8BIT    (0xFFu)



#define EXECUTE_UPDATE_BLOCK_NUMBER		((EXECUTE_END_ADDRESS - BT1_END_ADDRESS) / WRITE_DATA_SIZE)

#define COPY_FLAG_COMPLETE			(0xAAAA5555)


#ifdef ROM_SIZE_96KB
//ROM size = 96KB
#define TEMPORARY_START_ADDRESS           (0x00010000)
#define TEMPORARY_END_ADDRESS             (0x00017FFF)
#define EXECUTE_END_ADDRESS               (0x0000FFFF)

#elif ROM_SIZE_128KB
//ROM size = 128KB
#define TEMPORARY_START_ADDRESS           (0x00014000)
#define TEMPORARY_END_ADDRESS             (0x0001FFFF)
#define EXECUTE_END_ADDRESS               (0x00013FFF)

#elif ROM_SIZE_192KB
//ROM size = 192KB
#define TEMPORARY_START_ADDRESS           (0x0001C000)
#define TEMPORARY_END_ADDRESS             (0x0002FFFF)
#define EXECUTE_END_ADDRESS               (0x0001BFFF)

#elif ROM_SIZE_256KB
//ROM size = 256KB
#define TEMPORARY_START_ADDRESS           (0x00024000)
#define TEMPORARY_END_ADDRESS             (0x0003FFFF)
#define EXECUTE_END_ADDRESS               (0x00023FFF)

#elif ROM_SIZE_384KB
//ROM size = 384KB
#define TEMPORARY_START_ADDRESS           (0x00034000)
#define TEMPORARY_END_ADDRESS             (0x0005FFFF)
#define EXECUTE_END_ADDRESS               (0x00033FFF)

#elif ROM_SIZE_512KB
//ROM size = 512KB
#define TEMPORARY_START_ADDRESS           (0x00044000)
#define TEMPORARY_END_ADDRESS             (0x0007FFFF)
#define EXECUTE_END_ADDRESS               (0x00043FFF)

#elif ROM_SIZE_768KB
//ROM size = 768KB
#define TEMPORARY_START_ADDRESS           (0x00064000)
#define TEMPORARY_END_ADDRESS             (0x000BFFFF)
#define EXECUTE_END_ADDRESS               (0x00063FFF)

#endif



#if (COMPILER_CC == COMPILER)
#define MemCpy(s1, s2, n)       _COM_memcpy_ff(s1, s2, n)
#elif (COMPILER_IAR == COMPILER)
#define MemCpy(s1, s2, n)       memcpy_ff(s1, s2, n)
#endif

/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/
/* Start user code for type define. Do not edit comment generated here */
typedef enum e_ret
{
    ENUM_RET_STS_OK = 0,
	ENUM_RET_STS_RECEIVING,
    ENUM_RET_ERR_CFDF_SEQUENCER,
    ENUM_RET_ERR_EXTRA_SEQUENCER,
    ENUM_RET_ERR_ERASE,
    ENUM_RET_ERR_WRITE,
    ENUM_RET_ERR_BLANKCHECK,
    ENUM_RET_ERR_CHECK_WRITE_DATA,
    ENUM_RET_ERR_MODE_MISMATCHED,
    ENUM_RET_ERR_PARAMETER,
    ENUM_RET_ERR_CONFIGURATION,
	ENUM_RET_ERR_PACKET,
} e_ret_t;
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
/* Start user code for function. Do not edit comment generated here */
R_RFD_FAR_FUNC e_ret_t r_rfd_initialize(void);
R_RFD_FAR_FUNC e_ret_t r_cmd_start(void);
R_RFD_FAR_FUNC e_ret_t r_cmd_write(uint32_t *write_start_addr, uint32_t write_end_addr, uint8_t __near *write_data);
R_RFD_FAR_FUNC e_ret_t r_cmd_end(void);
R_RFD_FAR_FUNC e_ret_t r_CF_RangeErase(uint32_t start_addr, uint32_t end_addr);
R_RFD_FAR_FUNC e_ret_t r_CF_EraseBlock(uint32_t start_addr);
R_RFD_FAR_FUNC e_ret_t r_CF_WriteVerifySequence(uint32_t start_addr, uint16_t write_data_length, uint8_t __near *write_data);
R_RFD_FAR_FUNC e_ret_t r_CF_WriteData(uint32_t start_addr, uint16_t write_data_length, uint8_t __near *write_data);
R_RFD_FAR_FUNC e_ret_t r_CF_VerifyData(uint32_t start_addr, uint16_t data_length, uint8_t __near *write_data);
R_RFD_FAR_FUNC e_ret_t r_CheckCFDFSequencerEnd(void);
R_RFD_FAR_FUNC e_ret_t r_CheckExtraSequencerEnd(void);
R_RFD_FAR_FUNC e_ret_t r_RequestBootSwap(void);
R_RFD_FAR_FUNC e_ret_t r_CF_MemoryWrite(uint32_t *write_start_addr, uint32_t write_end_addr, uint8_t __near *write_data);
R_RFD_FAR_FUNC e_ret_t r_CF_TempCopy(void);
R_RFD_FAR_FUNC e_ret_t r_AsyncRecvPacketData(uint8_t *p_cmd_type, uint8_t rdata[]);
MD_STATUS r_Send_nByte(uint8_t *tx_buff, const uint16_t tx_num);
MD_STATUS r_SendACK(void);
uint16_t r_GetUARTRecvSize(void);
void r_ClearUARTRecvBuff(void);

extern volatile bool g_UART0_sendend;
/* End user code. Do not edit comment generated here */
#endif
